| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::Pose Class Reference
Core » Animation

A pose is a linked set of vertex offsets applying to one set of vertex data. More...

`#include <OgrePose.h>`

Inheritance diagram for Ogre::Pose:
[legend]

## Public Types
typedef ConstMapIterator< NormalsMap > | ConstNormalsIterator
| An iterator over the vertex offsets. More...
typedef ConstMapIterator< VertexOffsetMap > | ConstVertexOffsetIterator
| An iterator over the vertex offsets. More...
typedef MapIterator< NormalsMap > | NormalsIterator
| An iterator over the vertex offsets. More...
typedef std::map< size_t, Vector3 > | NormalsMap
| A collection of normals based on the vertex index. More...
typedef MapIterator< VertexOffsetMap > | VertexOffsetIterator
| An iterator over the vertex offsets. More...
typedef std::map< size_t, Vector3 > | VertexOffsetMap
| A collection of vertex offsets based on the vertex index. More...

## Public Member Functions
| Pose (ushort target, const String &name=BLANKSTRING)
| Constructor. More...
const HardwareVertexBufferSharedPtr & | _getHardwareVertexBuffer (const VertexData *origData) const
| Get a hardware vertex buffer version of the vertex offsets. More...
void | addVertex (size_t index, const Vector3 &offset)
| Adds an offset to a vertex for this pose. More...
void | addVertex (size_t index, const Vector3 &offset, const Vector3 &normal)
| Adds an offset to a vertex and a new normal for this pose. More...
void | clearVertices (void)
| Clear all vertices. More...
Pose * | clone (void) const
| Clone this pose and create another one configured exactly the same way (only really useful for cloning holders of this class). More...
bool | getIncludesNormals () const
| Return whether the pose vertices include normals. More...
const String & | getName (void) const
| Return the name of the pose (may be blank) More...
const NormalsMap & | getNormals (void) const
| Gets a const reference to the vertex offsets. More...
ConstNormalsIterator | getNormalsIterator (void) const
| Gets an iterator over all the vertex offsets. More...
NormalsIterator | getNormalsIterator (void)
| Gets an iterator over all the vertex offsets. More...
ushort | getTarget (void) const
| Return the target geometry index of the pose. More...
ConstVertexOffsetIterator | getVertexOffsetIterator (void) const
| Gets an iterator over all the vertex offsets. More...
VertexOffsetIterator | getVertexOffsetIterator (void)
| Gets an iterator over all the vertex offsets. More...
const VertexOffsetMap & | getVertexOffsets (void) const
| Gets a const reference to the vertex offsets. More...
void | removeVertex (size_t index)
| Remove a vertex offset. More...

## Detailed Description

A pose is a linked set of vertex offsets applying to one set of vertex data.

Remarks
  The target index referred to by the pose has a meaning set by the user of this class; but for example when used by Mesh it refers to either the Mesh shared geometry (0) or a SubMesh dedicated geometry (1+). Pose instances can be referred to by keyframes in VertexAnimationTrack in order to animate based on blending poses together.

## Member Typedef Documentation

## ◆ VertexOffsetMap

typedef std::map<size_t, Vector3> Ogre::Pose::VertexOffsetMap

A collection of vertex offsets based on the vertex index.

## ◆ VertexOffsetIterator

typedef MapIterator<VertexOffsetMap> Ogre::Pose::VertexOffsetIterator

An iterator over the vertex offsets.

## ◆ ConstVertexOffsetIterator

typedef ConstMapIterator<VertexOffsetMap> Ogre::Pose::ConstVertexOffsetIterator

An iterator over the vertex offsets.

## ◆ NormalsMap

typedef std::map<size_t, Vector3> Ogre::Pose::NormalsMap

A collection of normals based on the vertex index.

## ◆ NormalsIterator

typedef MapIterator<NormalsMap> Ogre::Pose::NormalsIterator

An iterator over the vertex offsets.

## ◆ ConstNormalsIterator

typedef ConstMapIterator<NormalsMap> Ogre::Pose::ConstNormalsIterator

An iterator over the vertex offsets.

## Constructor & Destructor Documentation

## ◆ Pose()

Ogre::Pose::Pose | ( | ushort | target,
|  | const String & | name = `BLANKSTRING`
| ) |  |

Constructor.

Parameters

  target | The target vertexdata index (0 for shared, 1+ for dedicated at the submesh index + 1)
  name | Optional name

## Member Function Documentation

## ◆ getName()

const String& Ogre::Pose::getName | ( | void |  | ) | const
| inline

Return the name of the pose (may be blank)

## ◆ getTarget()

ushort Ogre::Pose::getTarget | ( | void |  | ) | const
| inline

Return the target geometry index of the pose.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getIncludesNormals()

bool Ogre::Pose::getIncludesNormals | ( |  | ) | const
| inline

Return whether the pose vertices include normals.

## ◆ addVertex() [1/2]

void Ogre::Pose::addVertex | ( | size_t | index,
|  | const Vector3 & | offset
| ) |  |

Adds an offset to a vertex for this pose.

Parameters

  index | The vertex index
  offset | The position offset for this pose

## ◆ addVertex() [2/2]

void Ogre::Pose::addVertex | ( | size_t | index,
|  | const Vector3 & | offset,
|  | const Vector3 & | normal
| ) |  |

Adds an offset to a vertex and a new normal for this pose.

Parameters

  index | The vertex index
  offset | The position offset for this pose

## ◆ removeVertex()

void Ogre::Pose::removeVertex | ( | size_t | index | ) |

Remove a vertex offset.

## ◆ clearVertices()

void Ogre::Pose::clearVertices | ( | void |  | ) |

Clear all vertices.

## ◆ getVertexOffsetIterator() [1/2]

ConstVertexOffsetIterator Ogre::Pose::getVertexOffsetIterator | ( | void |  | ) | const

Gets an iterator over all the vertex offsets.

## ◆ getVertexOffsetIterator() [2/2]

VertexOffsetIterator Ogre::Pose::getVertexOffsetIterator | ( | void |  | ) |

Gets an iterator over all the vertex offsets.

## ◆ getVertexOffsets()

const VertexOffsetMap& Ogre::Pose::getVertexOffsets | ( | void |  | ) | const
| inline

Gets a const reference to the vertex offsets.

## ◆ getNormalsIterator() [1/2]

ConstNormalsIterator Ogre::Pose::getNormalsIterator | ( | void |  | ) | const

Gets an iterator over all the vertex offsets.

## ◆ getNormalsIterator() [2/2]

NormalsIterator Ogre::Pose::getNormalsIterator | ( | void |  | ) |

Gets an iterator over all the vertex offsets.

## ◆ getNormals()

const NormalsMap& Ogre::Pose::getNormals | ( | void |  | ) | const
| inline

Gets a const reference to the vertex offsets.

## ◆ _getHardwareVertexBuffer()

const HardwareVertexBufferSharedPtr& Ogre::Pose::_getHardwareVertexBuffer | ( | const VertexData * | origData | ) | const

Get a hardware vertex buffer version of the vertex offsets.

## ◆ clone()

Pose* Ogre::Pose::clone | ( | void |  | ) | const

Clone this pose and create another one configured exactly the same way (only really useful for cloning holders of this class).

The documentation for this class was generated from the following file:

- OgrePose.h